注册 登录  
 加关注
   显示下一条  |  关闭
温馨提示!由于新浪微博认证机制调整,您的新浪微博帐号绑定已过期,请重新绑定!立即重新绑定新浪微博》  |  关闭

信息 灵感 创新

I? =Information,Inspiration,Innovation

 
 
 

日志

 
 
关于我

we are 5. Mathematics, Computation, Programming, Engineering, and Making fun of life.

网易考拉推荐

【原创】AutoCAD中实体对象的拾取(二)  

2010-12-04 18:48:14|  分类: ObjectARX |  标签: |举报 |字号 订阅

  下载LOFTER 我的照片书  |

    前面提到的是使用Autodesk.AutoCAD.EditorInput命名空间下的PromptEntityOptionsPromptEntityResult类,这种方法仅提供一个简单的对象拾取方式,对于复杂的选择将会力不从心,AutoCAD提供了更好的解决方案——选择集(Selection Sets),相比较PromptEntityOptions类的方法,选择集的功能更加强大,它可以像PromptEntityOptions类那样选择单个的实体对象,但更显著的优点是可以选择多个对象,还可以添加过滤方式,例如只选择指定图层上的某种类型实体等。

选择集有两种使用方式,第一种是,当你要执行命令前,对象必须已被选择,另外一种则是命令和选择集交互方式,即可以在命令执行过程中动态的选择对象,并且命令也会根据用户的选择而采取相应的处理。

先说说第一种,该种选择方式在AutoCAD中被称之为前向选择集(个人翻译,原文为PickFirst Selection Set),顾名思义就是选择先于命令。例如AutoCAD中的erase命令,你可以先选定好图形,然后执行erase命令,这样该对象立即被删除,当然erase还有一种方式是先输入命令然后选择删除的实体,这将在第二种方式中说明。

       为了使用前向选择集,需要做一些前期的准备工作,一个是系统变量PICKFIRST必须设置为1,另外,使用了前向选择集的命令必须包含UsePickSet命令标志。

在设置好了相关参数后,获取前向选择集就会变得很简单,只需采用SelectImplied方法即可,该方法返回一个PromptSelectionResult对象,该对象包含了选择的结果,其中最重要的属性就是StatusValue了,分别代表选择结果的状态和选择集。下面的例子将创建我们自己的删除命令”MyErase”

[CommandMethod("MYERASE", CommandFlags.UsePickSet)]

public void MyErase()

{

    Document doc = Application.DocumentManager.MdiActiveDocument;

    Database db = doc.Database;

    Editor ed = doc.Editor;

    Transaction trans=db.TransactionManager.StartTransaction();

    PromptSelectionResult psr = ed.SelectImplied();

    //获取选择集

    SelectionSet ss = null;

    if (psr.Status == PromptStatus.OK)

    {

        ss = psr.Value;

        foreach (SelectedObject so in ss)

        {

            Entity ent = trans.GetObject(so.ObjectId, OpenMode.ForWrite) as Entity;

            ent.Erase(true);

        }

    }

    trans.Commit();

    trans.Dispose();

}

    加载后,如果不选择对象直接运行myerase命令,没有任何效果,这是由命令标志决定的,只有当选择了对象后使用该命令,被选择的对象才会被删除。

 

【原创】AutoCAD中实体对象的拾取(二) - 379910987 - 年轻人,要努力!!!

     第二种方式是命令和选择集交互方式,在命令可以先执行,然后等待用户选择,这种方式较第一种更方便有效,实现起来难易程度和第一种差不多。两者主要的不同在于选择集的获取。第一种在事先已经知道了,而第二种是动态的,未知的,这个时候需要用到Editor类的一些方法,例如GetSelection来提示用户选择对象SelectLast用来获取最后创建的对象;SelectWindow用来获取由两点确定的矩形中所有实体;SelectAtPoint用于获取通过给定点的所有对象;SelectAll则是获取当前空间中所有对象

[CommandMethod("MYERASE")]

public void MyErase()

{

    Document doc = Application.DocumentManager.MdiActiveDocument;

    Database db = doc.Database;

    Editor ed = doc.Editor;

    Transaction trans=db.TransactionManager.StartTransaction();

    PromptSelectionResult psr = ed.GetSelection();

    //获取选择集

    SelectionSet ss = null;

    if (psr.Status == PromptStatus.OK)

    {

        ss = psr.Value;

        foreach (SelectedObject so in ss)

        {

            Entity ent = trans.GetObject(so.ObjectId, OpenMode.ForWrite) as Entity;

            ent.Erase(true);

        }

    }

    trans.Commit();

    trans.Dispose();

}

    加载运行,输入命令”myerase”之后,将会在命令行中提示用户进行选择,选择完成之后回车,执行获取选择集后面的命令。

 

【原创】AutoCAD中实体对象的拾取(二) - 379910987 - 年轻人,要努力!!!

 如果对两种方法进行适当的组合,就能够实现AutoCAD下的erase命令了

  评论这张
 
阅读(1597)| 评论(3)
推荐 转载

历史上的今天

评论

<#--最新日志,群博日志--> <#--推荐日志--> <#--引用记录--> <#--博主推荐--> <#--随机阅读--> <#--首页推荐--> <#--历史上的今天--> <#--被推荐日志--> <#--上一篇,下一篇--> <#-- 热度 --> <#-- 网易新闻广告 --> <#--右边模块结构--> <#--评论模块结构--> <#--引用模块结构--> <#--博主发起的投票-->
 
 
 
 
 
 
 
 
 
 
 
 
 
 

页脚

网易公司版权所有 ©1997-2016